import { ISourceFile } from "./forest";
import { SyntaxNode } from "web-tree-sitter";
import { MultiMap } from "../util/multiMap";
import { NodeType } from "../util/treeUtils";
export declare type SymbolMap = MultiMap<string, ISymbol>;
export declare type IExposing = Map<string, ISymbol>;
export interface ISymbol {
    name: string;
    node: SyntaxNode;
    type: NodeType;
    constructors?: {
        name: string;
        node: SyntaxNode;
        type: "UnionConstructor" | "TypeAlias";
    }[];
}
export declare function bindTreeContainer(sourceFile: ISourceFile): void;
