import { SyntaxNode } from "web-tree-sitter";
import { Diagnostic } from "./diagnostics";
import { ISourceFile } from "./forest";
import { IProgram } from "./program";
export declare class PatternMatches {
    private program;
    private sourceFile;
    constructor(program: IProgram, sourceFile: ISourceFile);
    static check(region: SyntaxNode, patterns: SyntaxNode[], program: IProgram): Diagnostic[];
    static missing(patterns: SyntaxNode[], program: IProgram): string[];
    private getMissing;
    private checkPatterns;
    private isExhaustive;
    private toNonRedundantRows;
    private toSimplifiedUsefulRows;
    private isUseful;
    private specializeRowByCtor;
    private specializeRowByLiteral;
    private specializeRowByAnything;
    private isComplete;
    private collectCtors;
    private cons;
    private simplify;
}
