"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vscode_languageserver_1 = require("vscode-languageserver");
const codeActionProvider_1 = require("../codeActionProvider");
const elmReviewDiagnostics_1 = require("../diagnostics/elmReviewDiagnostics");
codeActionProvider_1.CodeActionProvider.registerCodeAction({
    errorCodes: ["elm_review"],
    fixId: "elm_review_fix",
    getCodeActions: (params) => {
        return params.context.diagnostics
            .filter(elmReviewDiagnostics_1.hasElmReviewFixes)
            .map(({ data: { fixes } }) => codeActionProvider_1.CodeActionProvider.getCodeAction(params, "Apply elm-review fix", fixes.map(({ range, string }) => vscode_languageserver_1.TextEdit.replace(range, string))));
    },
    getFixAllCodeAction: () => undefined,
});
//# sourceMappingURL=elmReviewFixAction.js.map