import { Diagnostic } from "vscode-languageserver";
import { ISourceFile } from "../../compiler/forest";
import { IDiagnostic } from "./diagnosticsProvider";
import { Range } from "vscode-languageserver-textdocument";
export declare type IElmReviewDiagnostic = IDiagnostic & {
    data: {
        code: "elm_review";
        fixes: {
            range: Range;
            string: string;
        }[];
    };
};
export declare function hasElmReviewFixes(diagnostic: Diagnostic): diagnostic is IElmReviewDiagnostic;
export declare class ElmReviewDiagnostics {
    private elmWorkspaceMatcher;
    private settings;
    private connection;
    constructor();
    createDiagnostics: (sourceFile: ISourceFile) => Promise<Map<string, IDiagnostic[]>>;
    private hasType;
    private checkForErrors;
}
