import { Range, TextEdit } from "vscode-languageserver";
export declare type NonEmptyArray<T> = [T, ...T[]];
export declare class Utils {
    static notUndefined<T>(this: void, x: T | undefined): x is T;
    static notUndefinedOrNull<T>(this: void, x: T | undefined | null): x is T;
    static arrayEquals<T>(a: T[], b: T[], itemEquals?: (a: T, b: T) => boolean): boolean;
    static rangeEquals(a: Range, b: Range): boolean;
    static rangeOverlaps(a: Range, b: Range): boolean;
    static getIndicesFromRange(range: Range, text: string): [number, number];
    static rotateArray<T>(array: T[], newStartIndex: number): T[];
    static mergeChanges(a: {
        [uri: string]: TextEdit[];
    }, b: {
        [uri: string]: TextEdit[];
    }): void;
}
